#include <iostream>
using namespace std;
int main()
{
    int n,m;cin>>n>>m;int suma=0,matrica[n][m],yy=0,y1=0;
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            int f;
            cin>>f;
            matrica[i][j]=f;
            if(i==1){
                yy+=f;
                y1+=(f*(m-1-j));
            }
        }
    }
    yy-=matrica[1][m-1];
    if(n==2){
        for(int i=m-1;0<i;--i){
            if(matrica[0][i]<y1){
                suma+=matrica[0][i];
                y1-=yy;
                yy-=matrica[1][i-1];
            }
            else{
                suma+=y1;
                break;
            }
        }
        cout<<suma;
    }
}